!+
! Module: dssdump_mod
!
! Authors:  Ian Stewart - SSC/LUX
!          
! Description: A tasklet to dump the contents of a DSS.
! 
! Comments: TODO:
! 
! $Id: module.f90,v 1.6 1998/05/27 13:45:39 gvacanti Exp $
!- 
module dssdump_mod

  use types

  use param
  use dal
  use errorHandling
!  use dss

  use dss_aux	! for dumpDss
  use dal_aux	! for splitSetTabName

  implicit none 

  private 

  ! Command-line parameters:
  character(255) ::&
    setName
  character(20) ::&
    extensionType,&
    tabName,&
    arrayName
  integer ::&
    extensionNum

  public dssdump

contains 

  !---------------------------------------------------------------------
  subroutine dssdump
  !---------------------------------------------------------------------

    implicit none

    type(DataSetT) :: set
    type(BlockT) :: dssBlock

    !-------------------------------------------------------------------
    ! Start

    call readParameters

    set = dataSet(setName, READ)

    select case(extensionType)
    case('bintabname')
      dssBlock = block(set, tabName)!, READ)

    case('arrayname')
      dssBlock = block(set, arrayName)!, READ)

    case('number')
      dssBlock = block(set, extensionNum)!, READ)

    case default
call error('badExtType',"The value of the --exttype parameter was not recognized.")
    end select

    call dumpDss(dssBlock) ! in ssclib/dss_aux

    call release(set)

  end subroutine dssdump

  !---------------------------------------------------------------------
  subroutine readParameters
  !---------------------------------------------------------------------

    implicit none

    !-------------------------------------------------------------------
    ! Start

    setName = stringParameter('set')
    extensionType = stringParameter('exttype')
    select case(extensionType)
    case('bintabname')
      tabName = stringParameter('table')

    case('arrayname')
      arrayName = stringParameter('array')

    case('number')
      extensionNum = intParameter('extn')

    case default
call error('badExtType',"The value of the --exttype parameter was not recognized.")
    end select

  end subroutine readParameters

  !---------------------------------------------------------------------
  subroutine template
  !---------------------------------------------------------------------

    implicit none

    !-------------------------------------------------------------------
    ! Start

  end subroutine template

end module dssdump_mod
